#---
# Excerpted from "Functional Programming: A PragPub Anthology",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/ppanth for more book information.
#---
defmodule CheckDigit do

  import Enum

  def valid?(numbers) do
    numbers = reverse(numbers)    
    numbers = map(numbers, fn char -> char - ?0 end)
    numbers = with_index(numbers)
    { odds, evens } = 
        partition(numbers, fn {_digit, index} -> rem(index, 2) == 0 end)
    sum_odd = reduce odds, 0, fn {number, _index}, sum -> sum + number end
    sum_even = reduce evens, 0, fn {number, _index}, sum ->
      result = number * 2
      if result >= 10 do
        result - 9 + sum
      else
        result + sum
      end
    end
    rem(sum_odd + sum_even, 10) == 0
  end

end
