#---
# Excerpted from "Functional Programming: A PragPub Anthology",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/ppanth for more book information.
#---
cheery = fn ->
  IO.puts "In spawned process #{inspect self()}"
  receive do
    { from_pid, :en, msg } ->
        send from_pid, "Well, hello #{msg}"
    { from_pid, :fr, msg } ->
        send from_pid, "Bonjour #{msg}"
    { from_pid, :es, msg } ->
        send from_pid, "Hola #{msg}"
  end
end

pid = cheery |> spawn

IO.puts "Spawned process #{inspect pid}"

send pid, { self(), :es, "mundo!" }

IO.puts "Message sent"


receive do
  msg -> IO.puts "The process said: #{inspect msg}"
end
