#---
# Excerpted from "Functional Programming: A PragPub Anthology",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/ppanth for more book information.
#---
defmodule Greeter do
  def start do
    spawn(&loop/0)
  end

  def greet(pid, language, msg) do
    send pid, { self(), language, msg }
  end

  def get_response(language) do
    receive do
      { :greeting, ^language, msg } -> msg
    end
  end

  defp loop do
    receive do
      { from_pid, language, msg } ->
        reply = case language do
                  :en -> "Well, hello #{msg}"
                  :fr -> "Bonjour #{msg}"
                  :es -> "Hola #{msg}"
                end
        send from_pid, { :greeting, language, reply }
    end
    loop()
  end
end

pid = Greeter.start
Greeter.greet(pid, :es, "mundo!")
Greeter.greet(pid, :fr, "tout le monde!")
Greeter.greet(pid, :en, "world!")

IO.puts Greeter.get_response(:fr)
IO.puts Greeter.get_response(:es)
IO.puts Greeter.get_response(:en)
